/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebhookEventMessageStatus type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEventMessageStatus{}

// WebhookEventMessageStatus struct for WebhookEventMessageStatus
type WebhookEventMessageStatus struct {
	Id string `json:"id"`
	Status MessageStatus `json:"status"`
}

// NewWebhookEventMessageStatus instantiates a new WebhookEventMessageStatus object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEventMessageStatus(id string, status MessageStatus) *WebhookEventMessageStatus {
	this := WebhookEventMessageStatus{}
	this.Id = id
	this.Status = status
	return &this
}

// NewWebhookEventMessageStatusWithDefaults instantiates a new WebhookEventMessageStatus object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventMessageStatusWithDefaults() *WebhookEventMessageStatus {
	this := WebhookEventMessageStatus{}
	return &this
}

// GetId returns the Id field value
func (o *WebhookEventMessageStatus) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMessageStatus) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *WebhookEventMessageStatus) SetId(v string) {
	o.Id = v
}

// GetStatus returns the Status field value
func (o *WebhookEventMessageStatus) GetStatus() MessageStatus {
	if o == nil {
		var ret MessageStatus
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMessageStatus) GetStatusOk() (*MessageStatus, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *WebhookEventMessageStatus) SetStatus(v MessageStatus) {
	o.Status = v
}

func (o WebhookEventMessageStatus) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEventMessageStatus) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["status"] = o.Status
	return toSerialize, nil
}

type NullableWebhookEventMessageStatus struct {
	value *WebhookEventMessageStatus
	isSet bool
}

func (v NullableWebhookEventMessageStatus) Get() *WebhookEventMessageStatus {
	return v.value
}

func (v *NullableWebhookEventMessageStatus) Set(val *WebhookEventMessageStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventMessageStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventMessageStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventMessageStatus(val *WebhookEventMessageStatus) *NullableWebhookEventMessageStatus {
	return &NullableWebhookEventMessageStatus{value: val, isSet: true}
}

func (v NullableWebhookEventMessageStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventMessageStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


